# Create our dummy Win32::TaskScheduler with the consts defined from
# https://github.com/djberg96/win32-taskscheduler/blob/ole/lib/win32/taskscheduler.rb
module RSpec
  module Puppet
    module Win32
      class TaskScheduler
        TASK_TIME_TRIGGER_ONCE = 0
        TASK_TIME_TRIGGER_DAILY = 1
        TASK_TIME_TRIGGER_WEEKLY = 2
        TASK_TIME_TRIGGER_MONTHLYDATE = 3
        TASK_TIME_TRIGGER_MONTHLYDOW = 4
        TASK_EVENT_TRIGGER_ON_IDLE = 5
        TASK_EVENT_TRIGGER_AT_SYSTEMSTART = 6
        TASK_EVENT_TRIGGER_AT_LOGON = 7
        ONCE = TASK_TIME_TRIGGER_ONCE
        DAILY = TASK_TIME_TRIGGER_DAILY
        WEEKLY = TASK_TIME_TRIGGER_WEEKLY
        MONTHLYDATE = TASK_TIME_TRIGGER_MONTHLYDATE
        MONTHLYDOW = TASK_TIME_TRIGGER_MONTHLYDOW
        ON_IDLE = TASK_EVENT_TRIGGER_ON_IDLE
        AT_SYSTEMSTART = TASK_EVENT_TRIGGER_AT_SYSTEMSTART
        AT_LOGON = TASK_EVENT_TRIGGER_AT_LOGON

        TASK_SUNDAY = 0x1
        TASK_MONDAY = 0x2
        TASK_TUESDAY = 0x4
        TASK_WEDNESDAY = 0x8
        TASK_THURSDAY = 0x10
        TASK_FRIDAY = 0x20
        TASK_SATURDAY = 0x40
        SUNDAY = TASK_SUNDAY
        MONDAY = TASK_MONDAY
        TUESDAY = TASK_TUESDAY
        WEDNESDAY = TASK_WEDNESDAY
        THURSDAY = TASK_THURSDAY
        FRIDAY = TASK_FRIDAY
        SATURDAY = TASK_SATURDAY

        TASK_FIRST_WEEK = 1
        TASK_SECOND_WEEK = 2
        TASK_THIRD_WEEK = 3
        TASK_FOURTH_WEEK = 4
        TASK_LAST_WEEK = 5
        FIRST_WEEK = TASK_FIRST_WEEK
        SECOND_WEEK = TASK_SECOND_WEEK
        THIRD_WEEK = TASK_THIRD_WEEK
        FOURTH_WEEK = TASK_FOURTH_WEEK
        LAST_WEEK = TASK_LAST_WEEK

        TASK_JANUARY = 0x1
        TASK_FEBRUARY = 0x2
        TASK_MARCH = 0x4
        TASK_APRIL = 0x8
        TASK_MAY = 0x10
        TASK_JUNE = 0x20
        TASK_JULY = 0x40
        TASK_AUGUST = 0x80
        TASK_SEPTEMBER = 0x100
        TASK_OCTOBER = 0x200
        TASK_NOVEMBER = 0x400
        TASK_DECEMBER = 0x800
        JANUARY = TASK_JANUARY
        FEBRUARY = TASK_FEBRUARY
        MARCH = TASK_MARCH
        APRIL = TASK_APRIL
        MAY = TASK_MAY
        JUNE = TASK_JUNE
        JULY = TASK_JULY
        AUGUST = TASK_AUGUST
        SEPTEMBER = TASK_SEPTEMBER
        OCTOBER = TASK_OCTOBER
        NOVEMBER = TASK_NOVEMBER
        DECEMBER = TASK_DECEMBER

        TASK_FLAG_INTERACTIVE = 0x1
        TASK_FLAG_DELETE_WHEN_DONE = 0x2
        TASK_FLAG_DISABLED = 0x4
        TASK_FLAG_START_ONLY_IF_IDLE = 0x10
        TASK_FLAG_KILL_ON_IDLE_END = 0x20
        TASK_FLAG_DONT_START_IF_ON_BATTERIES = 0x40
        TASK_FLAG_KILL_IF_GOING_ON_BATTERIES = 0x80
        TASK_FLAG_RUN_ONLY_IF_DOCKED = 0x100
        TASK_FLAG_HIDDEN = 0x200
        TASK_FLAG_RUN_IF_CONNECTED_TO_INTERNET = 0x400
        TASK_FLAG_RESTART_ON_IDLE_RESUME = 0x800
        TASK_FLAG_SYSTEM_REQUIRED = 0x1000
        TASK_FLAG_RUN_ONLY_IF_LOGGED_ON = 0x2000
        INTERACTIVE = TASK_FLAG_INTERACTIVE
        DELETE_WHEN_DONE = TASK_FLAG_DELETE_WHEN_DONE
        DISABLED = TASK_FLAG_DISABLED
        START_ONLY_IF_IDLE = TASK_FLAG_START_ONLY_IF_IDLE
        KILL_ON_IDLE_END = TASK_FLAG_KILL_ON_IDLE_END
        DONT_START_IF_ON_BATTERIES = TASK_FLAG_DONT_START_IF_ON_BATTERIES
        KILL_IF_GOING_ON_BATTERIES = TASK_FLAG_KILL_IF_GOING_ON_BATTERIES
        RUN_ONLY_IF_DOCKED = TASK_FLAG_RUN_ONLY_IF_DOCKED
        HIDDEN = TASK_FLAG_HIDDEN
        RUN_IF_CONNECTED_TO_INTERNET = TASK_FLAG_RUN_IF_CONNECTED_TO_INTERNET
        RESTART_ON_IDLE_RESUME = TASK_FLAG_RESTART_ON_IDLE_RESUME
        SYSTEM_REQUIRED = TASK_FLAG_SYSTEM_REQUIRED
        RUN_ONLY_IF_LOGGED_ON = TASK_FLAG_RUN_ONLY_IF_LOGGED_ON

        TASK_TRIGGER_FLAG_HAS_END_DATE = 0x1
        TASK_TRIGGER_FLAG_KILL_AT_DURATION_END = 0x2
        TASK_TRIGGER_FLAG_DISABLED = 0x4
        FLAG_HAS_END_DATE = TASK_TRIGGER_FLAG_HAS_END_DATE
        FLAG_KILL_AT_DURATION_END = TASK_TRIGGER_FLAG_KILL_AT_DURATION_END
        FLAG_DISABLED = TASK_TRIGGER_FLAG_DISABLED

        TASK_MAX_RUN_TIMES = 1440
        TASKS_TO_RETRIEVE = 5
        MAX_RUN_TIMES = TASK_MAX_RUN_TIMES

        TASK_VALIDATE_ONLY = 0x1
        TASK_CREATE = 0x2
        TASK_UPDATE = 0x4
        TASK_CREATE_OR_UPDATE = 0x6
        TASK_DISABLE = 0x8
        TASK_DONT_ADD_PRINCIPAL_ACE = 0x10
        TASK_IGNORE_REGISTRATION_TRIGGERS = 0x20

        TASK_LOGON_NONE = 0
        TASK_LOGON_PASSWORD = 1
        TASK_LOGON_S4U = 2
        TASK_LOGON_INTERACTIVE_TOKEN = 3
        TASK_LOGON_GROUP = 4
        TASK_LOGON_SERVICE_ACCOUNT = 5
        TASK_LOGON_INTERACTIVE_TOKEN_OR_PASSWORD = 6

        REALTIME_PRIORITY_CLASS = 0
        HIGH_PRIORITY_CLASS = 1
        ABOVE_NORMAL_PRIORITY_CLASS = 2
        NORMAL_PRIORITY_CLASS = 4
        BELOW_NORMAL_PRIORITY_CLASS = 7
        IDLE_PRIORITY_CLASS = 9
        REALTIME = REALTIME_PRIORITY_CLASS
        HIGH = HIGH_PRIORITY_CLASS
        ABOVE_NORMAL = ABOVE_NORMAL_PRIORITY_CLASS
        NORMAL = NORMAL_PRIORITY_CLASS
        BELOW_NORMAL = BELOW_NORMAL_PRIORITY_CLASS
        IDLE = IDLE_PRIORITY_CLASS

        CLSCTX_INPROC_SERVER  = 0x1
        CLSID_CTask =  [0x148BD520,0xA2AB,0x11CE,0xB1,0x1F,0x00,0xAA,0x00,0x53,0x05,0x03].pack('LSSC8')
        CLSID_CTaskScheduler =  [0x148BD52A,0xA2AB,0x11CE,0xB1,0x1F,0x00,0xAA,0x00,0x53,0x05,0x03].pack('LSSC8')
        IID_ITaskScheduler = [0x148BD527,0xA2AB,0x11CE,0xB1,0x1F,0x00,0xAA,0x00,0x53,0x05,0x03].pack('LSSC8')
        IID_ITask = [0x148BD524,0xA2AB,0x11CE,0xB1,0x1F,0x00,0xAA,0x00,0x53,0x05,0x03].pack('LSSC8')
        IID_IPersistFile = [0x0000010b,0x0000,0x0000,0xC0,0x00,0x00,0x00,0x00,0x00,0x00,0x46].pack('LSSC8')
      end
    end
  end
end

begin
  require 'win32/taskscheduler'
rescue LoadError
  module Win32
    TaskScheduler = RSpec::Puppet::Win32::TaskScheduler
  end
end
